import junit.framework.TestCase;

public class TestQueue extends TestCase
{
	public void testQueue0()
	{
		Out.println("testQueue0 mit verketteter Liste");
		q = new Queue0();
		runFIFO();
	}
	
	public void testQueue1()
	{
		Out.println("testQueue1 mit Array");
		q = new Queue1(5);
		runFIFO();
	}
	
	private char get()
	{
		char val = q.get();
		Out.print(String.format("* %s -", val)); 
		printQueue();
		return val;
	}
	
	private void put(char val)
	{
		q.put(val);
		Out.print(String.format("%c   -", val));
		printQueue();
	}
	
	private void printQueue()
	{
		q.print();
		Out.print(String.format(" (size=%d)", q.getSize()));
		Out.println();
	}
	
	private void runFIFO()
	{
		put('F');
		put('I');
		put('R');
		put('S');
		get();
		put('T');
		get();
		put('I');
		put('N');
		get();
		get();
		get();
		put('F');
		put('I');
		get();
		put('R');
		put('S');
		get();
		get();
		get();
		put('T');
		get();
		put('O');
		put('U');
		put('T');
		get();
		get();
		get();
		get();
		get();
		assertEquals(q.getSize(), 0);
	}
	private Queue q;
}
